<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactSearch StructType
 * @subpackage Structs
 */
class ContactSearch extends SearchRecord
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ContactSearchBasic
     */
    public $basic;
    /**
     * The callJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PhoneCallSearchBasic
     */
    public $callJoin;
    /**
     * The campaignResponseJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CampaignSearchBasic
     */
    public $campaignResponseJoin;
    /**
     * The caseJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SupportCaseSearchBasic
     */
    public $caseJoin;
    /**
     * The customerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSearchBasic
     */
    public $customerJoin;
    /**
     * The customerPrimaryJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSearchBasic
     */
    public $customerPrimaryJoin;
    /**
     * The eventJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CalendarEventSearchBasic
     */
    public $eventJoin;
    /**
     * The fileJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\FileSearchBasic
     */
    public $fileJoin;
    /**
     * The jobJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\JobSearchBasic
     */
    public $jobJoin;
    /**
     * The jobPrimaryJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\JobSearchBasic
     */
    public $jobPrimaryJoin;
    /**
     * The messagesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchBasic
     */
    public $messagesJoin;
    /**
     * The messagesFromJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchBasic
     */
    public $messagesFromJoin;
    /**
     * The messagesToJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\MessageSearchBasic
     */
    public $messagesToJoin;
    /**
     * The opportunityJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OpportunitySearchBasic
     */
    public $opportunityJoin;
    /**
     * The parentCustomerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSearchBasic
     */
    public $parentCustomerJoin;
    /**
     * The parentJobJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\JobSearchBasic
     */
    public $parentJobJoin;
    /**
     * The parentPartnerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PartnerSearchBasic
     */
    public $parentPartnerJoin;
    /**
     * The parentVendorJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\VendorSearchBasic
     */
    public $parentVendorJoin;
    /**
     * The partnerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PartnerSearchBasic
     */
    public $partnerJoin;
    /**
     * The partnerPrimaryJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\PartnerSearchBasic
     */
    public $partnerPrimaryJoin;
    /**
     * The purchasedItemJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ItemSearchBasic
     */
    public $purchasedItemJoin;
    /**
     * The taskJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TaskSearchBasic
     */
    public $taskJoin;
    /**
     * The transactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchBasic
     */
    public $transactionJoin;
    /**
     * The upsellItemJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ItemSearchBasic
     */
    public $upsellItemJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchBasic
     */
    public $userJoin;
    /**
     * The userNotesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\NoteSearchBasic
     */
    public $userNotesJoin;
    /**
     * The vendorJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\VendorSearchBasic
     */
    public $vendorJoin;
    /**
     * The vendorPrimaryJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\VendorSearchBasic
     */
    public $vendorPrimaryJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchJoin[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for ContactSearch
     * @uses ContactSearch::setBasic()
     * @uses ContactSearch::setCallJoin()
     * @uses ContactSearch::setCampaignResponseJoin()
     * @uses ContactSearch::setCaseJoin()
     * @uses ContactSearch::setCustomerJoin()
     * @uses ContactSearch::setCustomerPrimaryJoin()
     * @uses ContactSearch::setEventJoin()
     * @uses ContactSearch::setFileJoin()
     * @uses ContactSearch::setJobJoin()
     * @uses ContactSearch::setJobPrimaryJoin()
     * @uses ContactSearch::setMessagesJoin()
     * @uses ContactSearch::setMessagesFromJoin()
     * @uses ContactSearch::setMessagesToJoin()
     * @uses ContactSearch::setOpportunityJoin()
     * @uses ContactSearch::setParentCustomerJoin()
     * @uses ContactSearch::setParentJobJoin()
     * @uses ContactSearch::setParentPartnerJoin()
     * @uses ContactSearch::setParentVendorJoin()
     * @uses ContactSearch::setPartnerJoin()
     * @uses ContactSearch::setPartnerPrimaryJoin()
     * @uses ContactSearch::setPurchasedItemJoin()
     * @uses ContactSearch::setTaskJoin()
     * @uses ContactSearch::setTransactionJoin()
     * @uses ContactSearch::setUpsellItemJoin()
     * @uses ContactSearch::setUserJoin()
     * @uses ContactSearch::setUserNotesJoin()
     * @uses ContactSearch::setVendorJoin()
     * @uses ContactSearch::setVendorPrimaryJoin()
     * @uses ContactSearch::setCustomSearchJoin()
     * @param \StructType\ContactSearchBasic $basic
     * @param \StructType\PhoneCallSearchBasic $callJoin
     * @param \StructType\CampaignSearchBasic $campaignResponseJoin
     * @param \StructType\SupportCaseSearchBasic $caseJoin
     * @param \StructType\CustomerSearchBasic $customerJoin
     * @param \StructType\CustomerSearchBasic $customerPrimaryJoin
     * @param \StructType\CalendarEventSearchBasic $eventJoin
     * @param \StructType\FileSearchBasic $fileJoin
     * @param \StructType\JobSearchBasic $jobJoin
     * @param \StructType\JobSearchBasic $jobPrimaryJoin
     * @param \StructType\MessageSearchBasic $messagesJoin
     * @param \StructType\MessageSearchBasic $messagesFromJoin
     * @param \StructType\MessageSearchBasic $messagesToJoin
     * @param \StructType\OpportunitySearchBasic $opportunityJoin
     * @param \StructType\CustomerSearchBasic $parentCustomerJoin
     * @param \StructType\JobSearchBasic $parentJobJoin
     * @param \StructType\PartnerSearchBasic $parentPartnerJoin
     * @param \StructType\VendorSearchBasic $parentVendorJoin
     * @param \StructType\PartnerSearchBasic $partnerJoin
     * @param \StructType\PartnerSearchBasic $partnerPrimaryJoin
     * @param \StructType\ItemSearchBasic $purchasedItemJoin
     * @param \StructType\TaskSearchBasic $taskJoin
     * @param \StructType\TransactionSearchBasic $transactionJoin
     * @param \StructType\ItemSearchBasic $upsellItemJoin
     * @param \StructType\EmployeeSearchBasic $userJoin
     * @param \StructType\NoteSearchBasic $userNotesJoin
     * @param \StructType\VendorSearchBasic $vendorJoin
     * @param \StructType\VendorSearchBasic $vendorPrimaryJoin
     * @param \StructType\CustomSearchJoin[] $customSearchJoin
     */
    public function __construct(\StructType\ContactSearchBasic $basic = null, \StructType\PhoneCallSearchBasic $callJoin = null, \StructType\CampaignSearchBasic $campaignResponseJoin = null, \StructType\SupportCaseSearchBasic $caseJoin = null, \StructType\CustomerSearchBasic $customerJoin = null, \StructType\CustomerSearchBasic $customerPrimaryJoin = null, \StructType\CalendarEventSearchBasic $eventJoin = null, \StructType\FileSearchBasic $fileJoin = null, \StructType\JobSearchBasic $jobJoin = null, \StructType\JobSearchBasic $jobPrimaryJoin = null, \StructType\MessageSearchBasic $messagesJoin = null, \StructType\MessageSearchBasic $messagesFromJoin = null, \StructType\MessageSearchBasic $messagesToJoin = null, \StructType\OpportunitySearchBasic $opportunityJoin = null, \StructType\CustomerSearchBasic $parentCustomerJoin = null, \StructType\JobSearchBasic $parentJobJoin = null, \StructType\PartnerSearchBasic $parentPartnerJoin = null, \StructType\VendorSearchBasic $parentVendorJoin = null, \StructType\PartnerSearchBasic $partnerJoin = null, \StructType\PartnerSearchBasic $partnerPrimaryJoin = null, \StructType\ItemSearchBasic $purchasedItemJoin = null, \StructType\TaskSearchBasic $taskJoin = null, \StructType\TransactionSearchBasic $transactionJoin = null, \StructType\ItemSearchBasic $upsellItemJoin = null, \StructType\EmployeeSearchBasic $userJoin = null, \StructType\NoteSearchBasic $userNotesJoin = null, \StructType\VendorSearchBasic $vendorJoin = null, \StructType\VendorSearchBasic $vendorPrimaryJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setCallJoin($callJoin)
            ->setCampaignResponseJoin($campaignResponseJoin)
            ->setCaseJoin($caseJoin)
            ->setCustomerJoin($customerJoin)
            ->setCustomerPrimaryJoin($customerPrimaryJoin)
            ->setEventJoin($eventJoin)
            ->setFileJoin($fileJoin)
            ->setJobJoin($jobJoin)
            ->setJobPrimaryJoin($jobPrimaryJoin)
            ->setMessagesJoin($messagesJoin)
            ->setMessagesFromJoin($messagesFromJoin)
            ->setMessagesToJoin($messagesToJoin)
            ->setOpportunityJoin($opportunityJoin)
            ->setParentCustomerJoin($parentCustomerJoin)
            ->setParentJobJoin($parentJobJoin)
            ->setParentPartnerJoin($parentPartnerJoin)
            ->setParentVendorJoin($parentVendorJoin)
            ->setPartnerJoin($partnerJoin)
            ->setPartnerPrimaryJoin($partnerPrimaryJoin)
            ->setPurchasedItemJoin($purchasedItemJoin)
            ->setTaskJoin($taskJoin)
            ->setTransactionJoin($transactionJoin)
            ->setUpsellItemJoin($upsellItemJoin)
            ->setUserJoin($userJoin)
            ->setUserNotesJoin($userNotesJoin)
            ->setVendorJoin($vendorJoin)
            ->setVendorPrimaryJoin($vendorPrimaryJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\ContactSearchBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\ContactSearchBasic $basic
     * @return \StructType\ContactSearch
     */
    public function setBasic(\StructType\ContactSearchBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get callJoin value
     * @return \StructType\PhoneCallSearchBasic|null
     */
    public function getCallJoin()
    {
        return $this->callJoin;
    }
    /**
     * Set callJoin value
     * @param \StructType\PhoneCallSearchBasic $callJoin
     * @return \StructType\ContactSearch
     */
    public function setCallJoin(\StructType\PhoneCallSearchBasic $callJoin = null)
    {
        $this->callJoin = $callJoin;
        return $this;
    }
    /**
     * Get campaignResponseJoin value
     * @return \StructType\CampaignSearchBasic|null
     */
    public function getCampaignResponseJoin()
    {
        return $this->campaignResponseJoin;
    }
    /**
     * Set campaignResponseJoin value
     * @param \StructType\CampaignSearchBasic $campaignResponseJoin
     * @return \StructType\ContactSearch
     */
    public function setCampaignResponseJoin(\StructType\CampaignSearchBasic $campaignResponseJoin = null)
    {
        $this->campaignResponseJoin = $campaignResponseJoin;
        return $this;
    }
    /**
     * Get caseJoin value
     * @return \StructType\SupportCaseSearchBasic|null
     */
    public function getCaseJoin()
    {
        return $this->caseJoin;
    }
    /**
     * Set caseJoin value
     * @param \StructType\SupportCaseSearchBasic $caseJoin
     * @return \StructType\ContactSearch
     */
    public function setCaseJoin(\StructType\SupportCaseSearchBasic $caseJoin = null)
    {
        $this->caseJoin = $caseJoin;
        return $this;
    }
    /**
     * Get customerJoin value
     * @return \StructType\CustomerSearchBasic|null
     */
    public function getCustomerJoin()
    {
        return $this->customerJoin;
    }
    /**
     * Set customerJoin value
     * @param \StructType\CustomerSearchBasic $customerJoin
     * @return \StructType\ContactSearch
     */
    public function setCustomerJoin(\StructType\CustomerSearchBasic $customerJoin = null)
    {
        $this->customerJoin = $customerJoin;
        return $this;
    }
    /**
     * Get customerPrimaryJoin value
     * @return \StructType\CustomerSearchBasic|null
     */
    public function getCustomerPrimaryJoin()
    {
        return $this->customerPrimaryJoin;
    }
    /**
     * Set customerPrimaryJoin value
     * @param \StructType\CustomerSearchBasic $customerPrimaryJoin
     * @return \StructType\ContactSearch
     */
    public function setCustomerPrimaryJoin(\StructType\CustomerSearchBasic $customerPrimaryJoin = null)
    {
        $this->customerPrimaryJoin = $customerPrimaryJoin;
        return $this;
    }
    /**
     * Get eventJoin value
     * @return \StructType\CalendarEventSearchBasic|null
     */
    public function getEventJoin()
    {
        return $this->eventJoin;
    }
    /**
     * Set eventJoin value
     * @param \StructType\CalendarEventSearchBasic $eventJoin
     * @return \StructType\ContactSearch
     */
    public function setEventJoin(\StructType\CalendarEventSearchBasic $eventJoin = null)
    {
        $this->eventJoin = $eventJoin;
        return $this;
    }
    /**
     * Get fileJoin value
     * @return \StructType\FileSearchBasic|null
     */
    public function getFileJoin()
    {
        return $this->fileJoin;
    }
    /**
     * Set fileJoin value
     * @param \StructType\FileSearchBasic $fileJoin
     * @return \StructType\ContactSearch
     */
    public function setFileJoin(\StructType\FileSearchBasic $fileJoin = null)
    {
        $this->fileJoin = $fileJoin;
        return $this;
    }
    /**
     * Get jobJoin value
     * @return \StructType\JobSearchBasic|null
     */
    public function getJobJoin()
    {
        return $this->jobJoin;
    }
    /**
     * Set jobJoin value
     * @param \StructType\JobSearchBasic $jobJoin
     * @return \StructType\ContactSearch
     */
    public function setJobJoin(\StructType\JobSearchBasic $jobJoin = null)
    {
        $this->jobJoin = $jobJoin;
        return $this;
    }
    /**
     * Get jobPrimaryJoin value
     * @return \StructType\JobSearchBasic|null
     */
    public function getJobPrimaryJoin()
    {
        return $this->jobPrimaryJoin;
    }
    /**
     * Set jobPrimaryJoin value
     * @param \StructType\JobSearchBasic $jobPrimaryJoin
     * @return \StructType\ContactSearch
     */
    public function setJobPrimaryJoin(\StructType\JobSearchBasic $jobPrimaryJoin = null)
    {
        $this->jobPrimaryJoin = $jobPrimaryJoin;
        return $this;
    }
    /**
     * Get messagesJoin value
     * @return \StructType\MessageSearchBasic|null
     */
    public function getMessagesJoin()
    {
        return $this->messagesJoin;
    }
    /**
     * Set messagesJoin value
     * @param \StructType\MessageSearchBasic $messagesJoin
     * @return \StructType\ContactSearch
     */
    public function setMessagesJoin(\StructType\MessageSearchBasic $messagesJoin = null)
    {
        $this->messagesJoin = $messagesJoin;
        return $this;
    }
    /**
     * Get messagesFromJoin value
     * @return \StructType\MessageSearchBasic|null
     */
    public function getMessagesFromJoin()
    {
        return $this->messagesFromJoin;
    }
    /**
     * Set messagesFromJoin value
     * @param \StructType\MessageSearchBasic $messagesFromJoin
     * @return \StructType\ContactSearch
     */
    public function setMessagesFromJoin(\StructType\MessageSearchBasic $messagesFromJoin = null)
    {
        $this->messagesFromJoin = $messagesFromJoin;
        return $this;
    }
    /**
     * Get messagesToJoin value
     * @return \StructType\MessageSearchBasic|null
     */
    public function getMessagesToJoin()
    {
        return $this->messagesToJoin;
    }
    /**
     * Set messagesToJoin value
     * @param \StructType\MessageSearchBasic $messagesToJoin
     * @return \StructType\ContactSearch
     */
    public function setMessagesToJoin(\StructType\MessageSearchBasic $messagesToJoin = null)
    {
        $this->messagesToJoin = $messagesToJoin;
        return $this;
    }
    /**
     * Get opportunityJoin value
     * @return \StructType\OpportunitySearchBasic|null
     */
    public function getOpportunityJoin()
    {
        return $this->opportunityJoin;
    }
    /**
     * Set opportunityJoin value
     * @param \StructType\OpportunitySearchBasic $opportunityJoin
     * @return \StructType\ContactSearch
     */
    public function setOpportunityJoin(\StructType\OpportunitySearchBasic $opportunityJoin = null)
    {
        $this->opportunityJoin = $opportunityJoin;
        return $this;
    }
    /**
     * Get parentCustomerJoin value
     * @return \StructType\CustomerSearchBasic|null
     */
    public function getParentCustomerJoin()
    {
        return $this->parentCustomerJoin;
    }
    /**
     * Set parentCustomerJoin value
     * @param \StructType\CustomerSearchBasic $parentCustomerJoin
     * @return \StructType\ContactSearch
     */
    public function setParentCustomerJoin(\StructType\CustomerSearchBasic $parentCustomerJoin = null)
    {
        $this->parentCustomerJoin = $parentCustomerJoin;
        return $this;
    }
    /**
     * Get parentJobJoin value
     * @return \StructType\JobSearchBasic|null
     */
    public function getParentJobJoin()
    {
        return $this->parentJobJoin;
    }
    /**
     * Set parentJobJoin value
     * @param \StructType\JobSearchBasic $parentJobJoin
     * @return \StructType\ContactSearch
     */
    public function setParentJobJoin(\StructType\JobSearchBasic $parentJobJoin = null)
    {
        $this->parentJobJoin = $parentJobJoin;
        return $this;
    }
    /**
     * Get parentPartnerJoin value
     * @return \StructType\PartnerSearchBasic|null
     */
    public function getParentPartnerJoin()
    {
        return $this->parentPartnerJoin;
    }
    /**
     * Set parentPartnerJoin value
     * @param \StructType\PartnerSearchBasic $parentPartnerJoin
     * @return \StructType\ContactSearch
     */
    public function setParentPartnerJoin(\StructType\PartnerSearchBasic $parentPartnerJoin = null)
    {
        $this->parentPartnerJoin = $parentPartnerJoin;
        return $this;
    }
    /**
     * Get parentVendorJoin value
     * @return \StructType\VendorSearchBasic|null
     */
    public function getParentVendorJoin()
    {
        return $this->parentVendorJoin;
    }
    /**
     * Set parentVendorJoin value
     * @param \StructType\VendorSearchBasic $parentVendorJoin
     * @return \StructType\ContactSearch
     */
    public function setParentVendorJoin(\StructType\VendorSearchBasic $parentVendorJoin = null)
    {
        $this->parentVendorJoin = $parentVendorJoin;
        return $this;
    }
    /**
     * Get partnerJoin value
     * @return \StructType\PartnerSearchBasic|null
     */
    public function getPartnerJoin()
    {
        return $this->partnerJoin;
    }
    /**
     * Set partnerJoin value
     * @param \StructType\PartnerSearchBasic $partnerJoin
     * @return \StructType\ContactSearch
     */
    public function setPartnerJoin(\StructType\PartnerSearchBasic $partnerJoin = null)
    {
        $this->partnerJoin = $partnerJoin;
        return $this;
    }
    /**
     * Get partnerPrimaryJoin value
     * @return \StructType\PartnerSearchBasic|null
     */
    public function getPartnerPrimaryJoin()
    {
        return $this->partnerPrimaryJoin;
    }
    /**
     * Set partnerPrimaryJoin value
     * @param \StructType\PartnerSearchBasic $partnerPrimaryJoin
     * @return \StructType\ContactSearch
     */
    public function setPartnerPrimaryJoin(\StructType\PartnerSearchBasic $partnerPrimaryJoin = null)
    {
        $this->partnerPrimaryJoin = $partnerPrimaryJoin;
        return $this;
    }
    /**
     * Get purchasedItemJoin value
     * @return \StructType\ItemSearchBasic|null
     */
    public function getPurchasedItemJoin()
    {
        return $this->purchasedItemJoin;
    }
    /**
     * Set purchasedItemJoin value
     * @param \StructType\ItemSearchBasic $purchasedItemJoin
     * @return \StructType\ContactSearch
     */
    public function setPurchasedItemJoin(\StructType\ItemSearchBasic $purchasedItemJoin = null)
    {
        $this->purchasedItemJoin = $purchasedItemJoin;
        return $this;
    }
    /**
     * Get taskJoin value
     * @return \StructType\TaskSearchBasic|null
     */
    public function getTaskJoin()
    {
        return $this->taskJoin;
    }
    /**
     * Set taskJoin value
     * @param \StructType\TaskSearchBasic $taskJoin
     * @return \StructType\ContactSearch
     */
    public function setTaskJoin(\StructType\TaskSearchBasic $taskJoin = null)
    {
        $this->taskJoin = $taskJoin;
        return $this;
    }
    /**
     * Get transactionJoin value
     * @return \StructType\TransactionSearchBasic|null
     */
    public function getTransactionJoin()
    {
        return $this->transactionJoin;
    }
    /**
     * Set transactionJoin value
     * @param \StructType\TransactionSearchBasic $transactionJoin
     * @return \StructType\ContactSearch
     */
    public function setTransactionJoin(\StructType\TransactionSearchBasic $transactionJoin = null)
    {
        $this->transactionJoin = $transactionJoin;
        return $this;
    }
    /**
     * Get upsellItemJoin value
     * @return \StructType\ItemSearchBasic|null
     */
    public function getUpsellItemJoin()
    {
        return $this->upsellItemJoin;
    }
    /**
     * Set upsellItemJoin value
     * @param \StructType\ItemSearchBasic $upsellItemJoin
     * @return \StructType\ContactSearch
     */
    public function setUpsellItemJoin(\StructType\ItemSearchBasic $upsellItemJoin = null)
    {
        $this->upsellItemJoin = $upsellItemJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchBasic $userJoin
     * @return \StructType\ContactSearch
     */
    public function setUserJoin(\StructType\EmployeeSearchBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get userNotesJoin value
     * @return \StructType\NoteSearchBasic|null
     */
    public function getUserNotesJoin()
    {
        return $this->userNotesJoin;
    }
    /**
     * Set userNotesJoin value
     * @param \StructType\NoteSearchBasic $userNotesJoin
     * @return \StructType\ContactSearch
     */
    public function setUserNotesJoin(\StructType\NoteSearchBasic $userNotesJoin = null)
    {
        $this->userNotesJoin = $userNotesJoin;
        return $this;
    }
    /**
     * Get vendorJoin value
     * @return \StructType\VendorSearchBasic|null
     */
    public function getVendorJoin()
    {
        return $this->vendorJoin;
    }
    /**
     * Set vendorJoin value
     * @param \StructType\VendorSearchBasic $vendorJoin
     * @return \StructType\ContactSearch
     */
    public function setVendorJoin(\StructType\VendorSearchBasic $vendorJoin = null)
    {
        $this->vendorJoin = $vendorJoin;
        return $this;
    }
    /**
     * Get vendorPrimaryJoin value
     * @return \StructType\VendorSearchBasic|null
     */
    public function getVendorPrimaryJoin()
    {
        return $this->vendorPrimaryJoin;
    }
    /**
     * Set vendorPrimaryJoin value
     * @param \StructType\VendorSearchBasic $vendorPrimaryJoin
     * @return \StructType\ContactSearch
     */
    public function setVendorPrimaryJoin(\StructType\VendorSearchBasic $vendorPrimaryJoin = null)
    {
        $this->vendorPrimaryJoin = $vendorPrimaryJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchJoin[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $contactSearchCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$contactSearchCustomSearchJoinItem instanceof \StructType\CustomSearchJoin) {
                $invalidValues[] = is_object($contactSearchCustomSearchJoinItem) ? get_class($contactSearchCustomSearchJoinItem) : sprintf('%s(%s)', gettype($contactSearchCustomSearchJoinItem), var_export($contactSearchCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchJoin, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchJoin[] $customSearchJoin
     * @return \StructType\ContactSearch
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchJoin $item
     * @return \StructType\ContactSearch
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchJoin $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchJoin) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchJoin, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
